(var functions (require "./lib/functions.js"))

(def get-synonyms
     (# (f)
        (filter (keys functions.map)
                (# (k) (is (get functions.map k).synonymOf f)))))

(for (fname (keys functions.map))
     (let (func (get functions.map fname))
       (when (nil? func.synonymOf)
         (console.log (format "### ~name~\n\n~lazy~~synonyms~ ~lazy_or_synonyms~    (~name~ ~args~)\n\nTakes ~arg_count~ arguments.\n\n**Hot Cocoa Lisp**\n\n```lisp\n\n```\n\n**JavaScript**\n\n```javascript\n\n```\n" {
                              name fname
                              lazy (if func.lazy "_*_ " "")
                              synonyms (let (s (get-synonyms fname))
                                         (if (=0 (size s)) ""
                                           (format "Synonyms: ~~" [
                                                   ((map s (# (x) (cat "`" x "`"))).join ", ") ] )))
                              lazy_or_synonyms (if (or func.lazy (!= 0 (size (get-synonyms fname)))) "\n\n" "")
                              args (if (list? func.args)
                                       (cat
                                        ((map (range (get func.args 0))
                                              (# (x) (format "arg~~"
                                                             [ (+1 x) ] ))).join " ")
                                        "...")
                                     ((map (range func.args)
                                           (# (x) (format "arg~~"
                                                          [ (+1 x) ] ))).join " "))
                              arg_count (if (list? func.args) (func.args.join "-") func.args) } )))))